import clojure.lang.LockingTransaction;
import clojure.lang.Ref;

import java.util.concurrent.Callable;

public class Account  {
  private Ref balance;

  public Account(final int initialBalance) throws Exception {
    balance = new Ref(initialBalance); }

  public void deposit(final int amount) throws Exception {
    LockingTransaction.runInTransaction(
        new Callable<Void>() {
          public Void call() throws Exception {
            if (amount > 0)
              balance.set(getBalance() + amount);
            System.out.println("deposited... " + amount);
            //prints like this are bad idea within a transaction.
            return null;
          }
        }
    );
  }

  public void withdraw(final int amount) throws Exception {
    LockingTransaction.runInTransaction(new Callable<Void>() {
      public Void call() throws Exception {
        if(amount > 0 && getBalance() >= amount)
        {
          balance.set(getBalance() - amount);
        } else {
          throw new RuntimeException("no money");
        }
        return null;
      }
    });
  }

  public int getBalance() {
    return (Integer) balance.deref();
  }

  public int ensure() {
    balance.touch();
    return getBalance();
  }
}