import clojure.lang.LockingTransaction;
import sun.jvm.hotspot.debugger.cdbg.AccessControl;

import java.util.concurrent.Callable;

public class AccountService {

  public static void withdraw(final Account from,
          final Account constraining,
          final int amount) throws Exception {
    try {
      LockingTransaction.runInTransaction(new Callable<Void>() {
        public Void call() throws Exception {
          if(from.getBalance() + constraining.getBalance()
              - amount >= 1500) {
            from.withdraw(amount);
          } else {
            throw new RuntimeException("constraint violation");
          }
          return null;
        }
      });
      System.out.println("withdraw complete...");
    } catch(Exception ex) {
      System.out.println(ex.getMessage());
    }
  }

  public static void transfer(
      final Account from, final Account to,
      final int amount) throws Exception {
    try {
      LockingTransaction.runInTransaction(new Callable<Void>() {
        public Void call() throws Exception {
          System.out.println("transfering... " + amount);
          to.deposit(amount);
          Thread.sleep(3000); //simulated delay to make transactions collide
          from.withdraw(amount);
          return null;
        }
      });
      System.out.println("transfer complete..." + amount);
    } catch(Exception ex) {
      System.out.println(ex.getMessage());
    }
  }
}